【BZOJ4650】【NOI2016】优秀的拆分(后缀数组)

题面

BZOJ

Uoj

题解

如果我们知道以某个位置为开始/结尾的\(AA\)串的个数

那就直接做一下乘法就好

这个怎么求?

枚举一个位置

枚举串的长度

直接暴力算就好啦

至于是否可行,用\(SA\)求\(lcp\)就好啦

这样就是\(95\)分

NOI这么好拿部分分的???

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<vector>
#include<queue>
using namespace std;
#define ll long long
#define MAX 35000
int x[MAX],y[MAX],t[MAX];
int SA[MAX],height[MAX],rk[MAX];
int lg[MAX],n,p[20][MAX],a[MAX];
char s[MAX];
int g[MAX],f[MAX],T;
bool cmp(int i,int j,int k){return y[i]==y[j]&&y[i+k]==y[j+k];}
void init()
{
memset(SA,0,sizeof(SA));
memset(height,0,sizeof(height));
memset(rk,0,sizeof(rk));
memset(x,0,sizeof(x));
memset(y,0,sizeof(y));
memset(t,0,sizeof(t));
memset(a,0,sizeof(a));
}
void GetSA()
{
int m=50;
for(int i=1;i<=n;++i)t[x[i]=a[i]]++;
for(int i=1;i<=m;++i)t[i]+=t[i-1];
for(int i=n;i>=1;--i)SA[t[x[i]]--]=i;
for(int k=1;k<=n;k<<=1)
{
int p=0;
for(int i=n-k+1;i<=n;++i)y[++p]=i;
for(int i=1;i<=n;++i)if(SA[i]>k)y[++p]=SA[i]-k;
for(int i=0;i<=m;++i)t[i]=0;
for(int i=1;i<=n;++i)t[x[y[i]]]++;
for(int i=1;i<=m;++i)t[i]+=t[i-1];
for(int i=n;i>=1;--i)SA[t[x[y[i]]]--]=y[i];
swap(x,y);
x[SA[1]]=p=1;
for(int i=2;i<=n;++i)
x[SA[i]]=cmp(SA[i],SA[i-1],k)?p:++p;
if(p>=n)break;
m=p;
}
for(int i=1;i<=n;++i)rk[SA[i]]=i;
for(int i=1,j=0;i<=n;++i)
{
if(j)--j;
while(a[i+j]==a[SA[rk[i]-1]+j])++j;
height[rk[i]]=j;
}
}
void Pre()
{
memset(p,63,sizeof(p));
for(int i=1;i<=n;++i)p[0][i]=height[i];
for(int j=1;j<15;++j)
for(int i=1;i<=n;++i)
p[j][i]=min(p[j-1][i],p[j-1][i+(1<<(j-1))]);
}
int Query(int i,int j)
{
return min(p[lg[j-i+1]][i],p[lg[j-i+1]][j-(1<<lg[j-i+1])+1]);
}
int lcp(int i,int j)
{
int l=min(rk[i],rk[j])+1,r=max(rk[i],rk[j]);
return Query(l,r);
}
int main()
{
for(int i=2;i<=30000;++i)lg[i]=lg[i>>1]+1;
scanf("%d",&T);
while(T--)
{
init();
scanf("%s",s+1);
n=strlen(s+1);
for(int i=1;i<=n;++i)a[i]=s[i]-96;
GetSA();Pre();
for(int i=1;i<=n;++i)
{
g[i]=0;
for(int l=1;l+l+i-1<=n;++l)
if(lcp(i,i+l)>=l)g[i]++;
}
for(int i=2;i<=n;++i)
{
f[i]=0;
for(int l=1;i-l-l+1>0;++l)
if(lcp(i-l-l+1,i-l+1)>=l)f[i]++;
}
int ans=0;
for(int i=1;i<n;++i)
ans+=f[i]*g[i+1];
printf("%d\n",ans);
}
return 0;
}

\(95\)分的暴力太显然了。。

原来\(NOI\)都是这样送分???

为什么NOIP 没有这么好的福利


想想怎么优化吧。。。

肯定不能枚举长度之后再暴力算每一个位置

那么,我们要考虑一个方法,

可以一次性算出连续的位置

想想我们怎么求\(AA\)这种形式??

计算\(lcp(i,i+len)>=len\)是否成立

但是,如果\(lcp(i,i+len)>=len\)

我们就会发现,有一段区间内都是有满足条件的子串

所以我们可以一起计算

现在仔细思考怎么算

因为每次是\(i\)和\(i+len\)

所以我们只要枚举位置是\(len\)的倍数的地方就好

旁边的地方我们要想办法算出来

第一个,是向后如果可以增加的话

\(lcp(i,i+len)>=L\)我就会获得向后的一段连续区间

如果只算向后,会忽略掉向前的一段

所以再算一下\(lcs(i,i+len)\)这段,这两边拼起来

如果满足条件,证明这一段区间都是可行的

这样就可以差分全部\(+1\)

如果重复的部分够多

这样算可能会影响到别的块里面

所以要强制只在自己这一段里面算

具体的实现看代码啦

 #include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<vector>
#include<queue>
using namespace std;
#define ll long long
#define MAX 35000
int lg[MAX],n;
char s[MAX];
int g[MAX],f[MAX],T;
struct SA
{
int p[20][MAX],a[MAX];
int x[MAX],y[MAX],t[MAX];
int SA[MAX],height[MAX],rk[MAX];
bool cmp(int i,int j,int k){return y[i]==y[j]&&y[i+k]==y[j+k];}
void init()
{
memset(SA,0,sizeof(SA));
memset(height,0,sizeof(height));
memset(rk,0,sizeof(rk));
memset(x,0,sizeof(x));
memset(y,0,sizeof(y));
memset(t,0,sizeof(t));
memset(a,0,sizeof(a));
}
void GetSA()
{
int m=50;
for(int i=1;i<=n;++i)t[x[i]=a[i]]++;
for(int i=1;i<=m;++i)t[i]+=t[i-1];
for(int i=n;i>=1;--i)SA[t[x[i]]--]=i;
for(int k=1;k<=n;k<<=1)
{
int p=0;
for(int i=n-k+1;i<=n;++i)y[++p]=i;
for(int i=1;i<=n;++i)if(SA[i]>k)y[++p]=SA[i]-k;
for(int i=0;i<=m;++i)t[i]=0;
for(int i=1;i<=n;++i)t[x[y[i]]]++;
for(int i=1;i<=m;++i)t[i]+=t[i-1];
for(int i=n;i>=1;--i)SA[t[x[y[i]]]--]=y[i];
swap(x,y);
x[SA[1]]=p=1;
for(int i=2;i<=n;++i)
x[SA[i]]=cmp(SA[i],SA[i-1],k)?p:++p;
if(p>=n)break;
m=p;
}
for(int i=1;i<=n;++i)rk[SA[i]]=i;
for(int i=1,j=0;i<=n;++i)
{
if(j)--j;
while(a[i+j]==a[SA[rk[i]-1]+j])++j;
height[rk[i]]=j;
}
}
void Pre()
{
memset(p,63,sizeof(p));
for(int i=1;i<=n;++i)p[0][i]=height[i];
for(int j=1;j<15;++j)
for(int i=1;i<=n;++i)
p[j][i]=min(p[j-1][i],p[j-1][i+(1<<(j-1))]);
}
int Query(int i,int j)
{
return min(p[lg[j-i+1]][i],p[lg[j-i+1]][j-(1<<lg[j-i+1])+1]);
}
int lcp(int i,int j)
{
int l=min(rk[i],rk[j])+1,r=max(rk[i],rk[j]);
return Query(l,r);
}
}A,B;
int main()
{
for(int i=2;i<=30000;++i)lg[i]=lg[i>>1]+1;
scanf("%d",&T);
while(T--)
{
A.init();B.init();
scanf("%s",s+1);
n=strlen(s+1);
for(int i=1;i<=n;++i)A.a[i]=s[i]-96;
for(int i=1;i<=n;++i)B.a[n-i+1]=s[i]-96;
A.GetSA();A.Pre();B.GetSA();B.Pre();
for(int i=1;i<=n;++i)g[i]=f[i]=0;
for(int len=1;len<=n/2;++len)
{
for(int i=len,j=i+len;j<=n;i+=len,j+=len)
{
int x=min(A.lcp(i,j),len);
int y=min(B.lcp(n-i+2,n-j+2),len-1);
int t=x+y-len+1;
if(x+y>=len)
{
g[i-y]++;g[i-y+t]--;
f[j+x-t]++;f[j+x]--;
}
}
} for(int i=1;i<=n;++i)g[i]+=g[i-1];
for(int i=1;i<=n;++i)f[i]+=f[i-1];
ll ans=0;
for(int i=1;i<n;++i)
ans+=1ll*f[i]*g[i+1];
printf("%lld\n",ans);
}
return 0;
}

【BZOJ4650】【NOI2016】优秀的拆分(后缀数组)的更多相关文章

  1. [NOI2016]优秀的拆分 后缀数组

    题面:洛谷 题解: 因为对于原串的每个长度不一定等于len的拆分而言,如果合法,它将只会被对应的子串统计贡献. 所以子串这个限制相当于是没有的. 所以我们只需要对于每个位置i求出f[i]表示以i为开头 ...

  2. BZOJ.4650.[NOI2016]优秀的拆分(后缀数组 思路)

    BZOJ 洛谷 令\(st[i]\)表示以\(i\)为开头有多少个\(AA\)这样的子串,\(ed[i]\)表示以\(i\)结尾有多少个\(AA\)这样的子串.那么\(Ans=\sum_{i=1}^{ ...

  3. UOJ #219 BZOJ 4650 luogu P1117 [NOI2016]优秀的拆分 (后缀数组、ST表)

    连NOI Day1T1都不会做...看了题解都写不出来还要抄Claris的代码.. 题目链接: (luogu)https://www.luogu.org/problemnew/show/P1117 ( ...

  4. BZOJ 4650 [Noi2016]优秀的拆分 ——后缀数组

    我们只需要统计在某一个点开始的形如$AA$字符串个数,和结束的个数相乘求和. 首先枚举循环节的长度L.即$\mid (A) \mid=L$ 然后肯定会经过s[i]和[i+L]至少两个点. 然后我们可以 ...

  5. [UOJ#219][BZOJ4650][Noi2016]优秀的拆分

    [UOJ#219][BZOJ4650][Noi2016]优秀的拆分 试题描述 如果一个字符串可以被拆分为 AABBAABB 的形式,其中 A 和 B 是任意非空字符串,则我们称该字符串的这种拆分是优秀 ...

  6. [NOI2016]优秀的拆分(SA数组)

    [NOI2016]优秀的拆分 题目描述 如果一个字符串可以被拆分为 \(AABB\) 的形式,其中 A和 B是任意非空字符串,则我们称该字符串的这种拆分是优秀的. 例如,对于字符串 \(aabaaba ...

  7. BZOJ4650 [NOI2016]优秀的拆分 【后缀数组】

    题目 如果一个字符串可以被拆分为 AABBAABB 的形式,其中 AA 和 BB 是任意非空字符串,则我们称该字符串的这种拆 分是优秀的.例如,对于字符串 aabaabaa,如果令 A=aabA=aa ...

  8. bzoj千题计划317:bzoj4650: [Noi2016]优秀的拆分(后缀数组+差分)

    https://www.lydsy.com/JudgeOnline/problem.php?id=4650 如果能够预处理出 suf[i] 以i结尾的形式为AA的子串个数 pre[i] 以i开头的形式 ...

  9. UOJ#219. 【NOI2016】优秀的拆分 [后缀数组 ST表]

    #219. [NOI2016]优秀的拆分 题意:求有多少AABB样子的子串,拆分不同的同一个子串算多个 一开始一直想直接求,并不方便 然后看了一眼Claris的题解的第一行就有思路了 如果分开,求\( ...

  10. UOJ#219/BZOJ4650 [NOI2016]优秀的拆分 字符串 SA ST表

    原文链接http://www.cnblogs.com/zhouzhendong/p/9025092.html 题目传送门 - UOJ#219 (推荐,题面清晰) 题目传送门 - BZOJ4650 题意 ...

随机推荐

  1. Google 搜索引擎语法

    Google Hack原理很简单,就是利用搜索引擎强大的搜索能力,来查找一些存在漏洞的网站.要利用Google来查找网站的漏洞自然要学会Google这个搜索引擎的语法了.下面先给大家讲解一下Googl ...

  2. IOS开发之记录用户登陆状态,ios开发用户登陆

    IOS开发之记录用户登陆状态,ios开发用户登陆 上一篇博客中提到了用CoreData来进行数据的持久化,CoreData的配置和使用步骤还是挺复杂的.但熟悉CoreData的使用流程后,CoreDa ...

  3. datatables行编辑中,某个字段用户显示和用于行编辑名称不同时的处理。

    比如tag这个字段,对应服务端bean的tag,但是在页面显示时需要为String类型的tagName,那么在行编辑时可以用以下的方式处理.

  4. cf B. Mishka and trip (数学)

    题意   Mishka想要去一个国家旅行,这个国家共有个城市,城市通过道路形成一个环,即第i个城市和第个城市之间有一条道路,此外城市和之间有一条道路.这个城市中有个首中心城市,中心城市与每个城市(除了 ...

  5. UVA - 11636 Hello World! (贪心)

    思路:复制次数最少并且可以部分复制,那么贪心地让当前尽量多的复制,如果最后一次复制会超过n,那就部分复制.即满足并且x尽量小. AC代码 #include <stdio.h> const ...

  6. Web自动化之Headless Chrome开发工具库

    命令行运行Headless Chrome Chrome 安装(需要带梯子) 下载地址 几个版本的比较 Chromium 不是Chrome,但Chrome的内容基本来源于Chromium,这个是开源的版 ...

  7. c#判断外部可执行程序是否已打开(若未打开则打开)

    #region 通过当前代码执行路径向上找到相关exe,并根据processes.Length判断是否已启动 private bool CheckAndOpenExe(string exeName) ...

  8. MySQL参数log_bin_trust_function_creators介绍

    MySQL的有个参数log_bin_trust_function_creators,官方文档对这个参数的介绍.解释如下所示: log_bin_trust_function_creators Comma ...

  9. Android应用Home键后Launcher重复启动问题

    通过系统方式(系统安装器)安装应用,点击"打开"按钮,进入应用主界面,按home键后,点击应用图标进入,应用会出现重新启动.当完全退出应用后,再通过启动图标进入应用,便不会出现重复 ...

  10. mongodb命令行group分组和java代码中group分组

    group分组统计是数据库比较常用的功能,mongodb也不例外.不过相对于普通的增删改查,group操作就略微麻烦一些, 这里对group在shell中的操作.使用java原生代码操作以及集成spr ...